Page MenuHomePhabricator

[PS4] Support dllimport/export attributes
ClosedPublic

Authored by bd1976llvm on Oct 29 2020, 8:31 PM.

Details

Summary

For PS4 development we support dllimport/export annotations in source code. This patch enables the dllimport/export attributes on PS4 by adding a new function to query the triple for whether dllimport/export are supported and using that function to decide whether these attributes are supported. This means we can drop the use of "TargetArch" in the .td file which is an improvement as dllimport/export support isn't really a function of the architecture.

I have included a simple codgen test to show that the attributes are accepted and have an effect on codegen. I have also enabled the DLLExportStaticLocal and DLLImportStaticLocal attributes, which we support downstream. However, I am unable to write a test for these attributes until other patches for PS4 dllimport/export handling land upstream. Whilst writing this patch I noticed that, as these attributes are internal, they do not need to be target specific (when these attributes are added internally in Clang the target specific checks have already been run); however, I think leaving them target specific is fine because it isn't harmful and they "really are" target specific even if that has no functional impact.

Diff Detail

Event Timeline

bd1976llvm created this revision.Oct 29 2020, 8:31 PM
bd1976llvm requested review of this revision.Oct 29 2020, 8:31 PM
hans added a comment.Oct 30 2020, 1:01 AM

Looks reasonable to me.

aaron.ballman accepted this revision.Oct 30 2020, 4:48 AM

LGTM!

llvm/include/llvm/ADT/Triple.h
787

Indentation looks a bit off here

This revision is now accepted and ready to land.Oct 30 2020, 4:48 AM
bd1976llvm updated this revision to Diff 302241.Nov 2 2020, 3:45 AM

Fixed indentation.

bd1976llvm marked an inline comment as done.Nov 2 2020, 3:48 AM
bd1976llvm added inline comments.
llvm/include/llvm/ADT/Triple.h
787

Thanks!

Herald added a project: Restricted Project. · View Herald TranscriptNov 2 2020, 6:26 AM
Herald added a subscriber: cfe-commits. · View Herald Transcript